diff --git a/src/backend/nodes/bitmapset.c b/src/backend/nodes/bitmapset.c
index 344266199..2e1830e2d 100644
--- a/src/backend/nodes/bitmapset.c
+++ b/src/backend/nodes/bitmapset.c
@@ -21,7 +21,7 @@
 #include "postgres.h"
 
 #include "access/hash.h"
-#include "storage/dsm_alloc.h"
+#include "storage/shm_alloc.h"
 
 
 #define WORDNUM(x)	((x) / BITS_PER_BITMAPWORD)
@@ -864,7 +864,7 @@ bms_hash_value(const Bitmapset *a)
 								   (lastword + 1) * sizeof(bitmapword)));
 }
 
-Bitmapset *dsm_bms_add_member(Bitmapset *bms, int x)
+Bitmapset *shm_bms_add_member(Bitmapset *bms, int x)
 {
 	int	wordnum, bitnum, nwords;
 
@@ -882,13 +882,13 @@ Bitmapset *dsm_bms_add_member(Bitmapset *bms, int x)
 		Bitmapset *old;
 
 		old = bms;
-		bms = (Bitmapset *) dsm_alloc0(BITMAPSET_SIZE(wordnum + 1));
+		bms = (Bitmapset *) ShmemDynAlloc0(BITMAPSET_SIZE(wordnum + 1));
 		bms->nwords = wordnum + 1;
 
 		if (old)
 		{
 			memcpy(bms->words, old->words, nwords * sizeof(bitmapword));
-			dsm_free(old);
+			ShmemDynFree(old);
 		}
 	}
 
@@ -896,8 +896,8 @@ Bitmapset *dsm_bms_add_member(Bitmapset *bms, int x)
 	return bms;
 }
 
-void dsm_bms_free(Bitmapset *bms)
+void shm_bms_free(Bitmapset *bms)
 {
 	if (bms)
-		dsm_free(bms);
+		ShmemDynFree(bms);
 }
diff --git a/src/backend/pipeline/cont_xact.c b/src/backend/pipeline/cont_xact.c
index 343b9656b..19e2ca6b0 100644
--- a/src/backend/pipeline/cont_xact.c
+++ b/src/backend/pipeline/cont_xact.c
@@ -15,7 +15,7 @@
 #include "nodes/bitmapset.h"
 #include "pipeline/cont_xact.h"
 #include "pipeline/cqproc.h"
-#include "storage/dsm_alloc.h"
+#include "storage/shm_alloc.h"
 
 #define SLEEP_MS 5
 #define CHECK_CRASH_CYCLES 5
@@ -27,7 +27,7 @@ List *MyAcks = NIL;
 
 StreamBatch *StreamBatchCreate(Bitmapset *readers, int num_tuples)
 {
-	char *ptr = dsm_alloc0(sizeof(StreamBatch) + BITMAPSET_SIZE(readers->nwords) + (bms_num_members(readers) * sizeof(int)));
+	char *ptr = ShmemDynAlloc0(sizeof(StreamBatch) + BITMAPSET_SIZE(readers->nwords) + (bms_num_members(readers) * sizeof(int)));
 	StreamBatch *batch = (StreamBatch *) ptr;
 	int cq_id;
 	int i = 0;
@@ -106,7 +106,7 @@ void StreamBatchWaitAndRemove(StreamBatch *batch)
 		cycle++;
 	}
 
-	dsm_free(batch);
+	ShmemDynFree(batch);
 }
 
 void StreamBatchIncrementNumCTuples(StreamBatch *batch)
diff --git a/src/backend/pipeline/cqproc.c b/src/backend/pipeline/cqproc.c
index 208ece057..f6cb5ab49 100644
--- a/src/backend/pipeline/cqproc.c
+++ b/src/backend/pipeline/cqproc.c
@@ -37,8 +37,8 @@
 #include "pipeline/tuplebuf.h"
 #include "postmaster/bgworker.h"
 #include "regex/regex.h"
-#include "storage/dsm_alloc.h"
-#include "storage/dsm_array.h"
+#include "storage/shm_alloc.h"
+#include "storage/shm_array.h"
 #include "storage/spin.h"
 #include "tcop/dest.h"
 #include "tcop/pquery.h"
@@ -65,7 +65,7 @@ typedef struct CQProcRunArgs
 	Oid dboid;
 } CQProcRunArgs;
 
-static DSMArray **CQProcArray = NULL;
+static ShmemArray **CQProcArray = NULL;
 
 /*
  * InitCQProcState
@@ -80,10 +80,10 @@ InitCQProcState(void)
 
 	LWLockAcquire(PipelineMetadataLock, LW_EXCLUSIVE);
 
-	CQProcArray = (DSMArray **) ShmemInitStruct("CQProcArray", sizeof(DSMArray *), &found);
+	CQProcArray = (ShmemArray **) ShmemInitStruct("CQProcArray", sizeof(ShmemArray *), &found);
 
 	if (!found)
-		*CQProcArray = (DSMArray *) dsm_array_new(sizeof(CQProcEntry *));
+		*CQProcArray = (ShmemArray *) ShmemArrayInit(sizeof(CQProcEntry *));
 
 	LWLockRelease(PipelineMetadataLock);
 }
@@ -115,7 +115,7 @@ GetProcessGroupSize(int id)
 CQProcEntry*
 CQProcEntryCreate(int id, int parallelism)
 {
-	CQProcEntry	*entry = (CQProcEntry *) dsm_alloc0(sizeof(CQProcArray));
+	CQProcEntry	*entry = (CQProcEntry *) ShmemDynAlloc0(sizeof(CQProcArray));
 
 	entry->id = id;
 	/* New entry, initialize it with the process group size */
@@ -126,15 +126,15 @@ CQProcEntryCreate(int id, int parallelism)
 	entry->shm_query = NULL;
 
 	entry->combiner.last_pid = 0;
-	entry->workers = dsm_alloc0(sizeof(CQBackgroundWorkerHandle) * NUM_WORKERS(entry));
+	entry->workers = ShmemDynAlloc0(sizeof(CQBackgroundWorkerHandle) * NUM_WORKERS(entry));
 
 	SpinLockInit(&entry->mutex);
 
-	dsm_array_set(*CQProcArray, id, &entry);
+	ShmemArraySet(*CQProcArray, id, &entry);
 
 	/* Expand Latch arrays on TupleBuffers, if needed. */
-	dsm_array_set(WorkerTupleBuffer->latches, id, NULL);
-	dsm_array_set(CombinerTupleBuffer->latches, id, NULL);
+	ShmemArraySet(WorkerTupleBuffer->latches, id, NULL);
+	ShmemArraySet(CombinerTupleBuffer->latches, id, NULL);
 
 	return entry;
 }
@@ -154,13 +154,13 @@ CQProcEntryRemove(int id)
 	if (entry)
 	{
 		if (entry->workers)
-			dsm_free(entry->workers);
+			ShmemDynFree(entry->workers);
 		if (entry->shm_query)
-			dsm_free(entry->shm_query);
+			ShmemDynFree(entry->shm_query);
 	}
 
-	dsm_free(entry);
-	dsm_array_set(*CQProcArray, id, NULL);
+	ShmemDynFree(entry);
+	ShmemArraySet(*CQProcArray, id, NULL);
 }
 
 /*
@@ -171,7 +171,7 @@ CQProcEntryRemove(int id)
 CQProcEntry*
 GetCQProcEntry(int id)
 {
-	return *(CQProcEntry **) dsm_array_get(*CQProcArray, id);
+	return *(CQProcEntry **) ShmemArrayGet(*CQProcArray, id);
 }
 
 /*
@@ -382,7 +382,7 @@ cq_bg_main(Datum d, char *additional, Size additionalsize)
 	 * This will happen when the BG worker is being respawned after a full
 	 * reset cycle.
 	 */
-	if (!dsm_is_valid_ptr(args->query))
+	if (!ShmemDynAddrIsValid(args->query))
 		return;
 
 	/* Set all globals variables */
@@ -520,7 +520,7 @@ RunCQProcs(const char *cvname, void *_state, CQProcEntry *entry, Oid dboid)
 	if (entry->shm_query == NULL)
 	{
 		char *q = GetQueryString((char *) cvname, true);
-		entry->shm_query = dsm_alloc(strlen(q) + 1);
+		entry->shm_query = ShmemDynAlloc(strlen(q) + 1);
 		strcpy(entry->shm_query, q);
 	}
 
diff --git a/src/backend/pipeline/stream.c b/src/backend/pipeline/stream.c
index 192fcb83b..0e64d7b3a 100644
--- a/src/backend/pipeline/stream.c
+++ b/src/backend/pipeline/stream.c
@@ -25,7 +25,7 @@
 #include "parser/parse_target.h"
 #include "pipeline/cont_xact.h"
 #include "pipeline/stream.h"
-#include "storage/dsm_alloc.h"
+#include "storage/shm_alloc.h"
 #include "storage/ipc.h"
 #include "utils/builtins.h"
 #include "tcop/tcopprot.h"
diff --git a/src/backend/pipeline/tuplebuf.c b/src/backend/pipeline/tuplebuf.c
index f9a5a10f5..477979455 100644
--- a/src/backend/pipeline/tuplebuf.c
+++ b/src/backend/pipeline/tuplebuf.c
@@ -21,7 +21,7 @@
 #include "executor/tuptable.h"
 #include "nodes/bitmapset.h"
 #include "nodes/print.h"
-#include "storage/dsm_alloc.h"
+#include "storage/shm_alloc.h"
 #include "storage/lwlock.h"
 #include "storage/spin.h"
 #include "storage/proc.h"
@@ -376,7 +376,7 @@ TupleBufferInit(char *name, Size size, LWLock *head_lock, LWLock *tail_lock, uin
 		buf->head = buf->tail = NULL;
 
 		buf->waiters = NULL;
-		buf->latches = dsm_array_new(sizeof(Latch) * max_readers);
+		buf->latches = ShmemArrayInit(sizeof(Latch) * max_readers);
 
 		SpinLockInit(&buf->mutex);
 
@@ -498,7 +498,7 @@ TupleBufferPinNextSlot(TupleBufferReader *reader)
 			ListCell *lc;
 			bool found = false;
 
-			if (!dsm_is_valid_ptr(ack.batch) || ack.batch_id != ack.batch->id)
+			if (!ShmemDynAddrIsValid(ack.batch) || ack.batch_id != ack.batch->id)
 				continue;
 
 			foreach(lc, MyAcks) {
@@ -580,7 +580,7 @@ TupleBufferIsEmpty(TupleBuffer *buf)
 void
 TupleBufferInitLatch(TupleBuffer *buf, uint32_t cq_id, uint8_t reader_id, Latch *proclatch)
 {
-	Latch *latches = dsm_array_get(buf->latches, cq_id);
+	Latch *latches = ShmemArrayGet(buf->latches, cq_id);
 	memcpy(&latches[reader_id], proclatch, sizeof(Latch));
 }
 
@@ -595,14 +595,14 @@ TupleBufferWait(TupleBuffer *buf, uint32_t cq_id, uint8_t reader_id)
 	SpinLockAcquire(&buf->mutex);
 	if (!TupleBufferHasUnreadSlots())
 	{
-		buf->waiters = dsm_bms_add_member(buf->waiters, cq_id);
+		buf->waiters = shm_bms_add_member(buf->waiters, cq_id);
 		should_wait = true;
 	}
 	SpinLockRelease(&buf->mutex);
 
 	if (should_wait)
 	{
-		Latch *latches = dsm_array_get(buf->latches, cq_id);
+		Latch *latches = ShmemArrayGet(buf->latches, cq_id);
 		WaitLatch((&latches[reader_id]), WL_LATCH_SET, 0);
 	}
 }
@@ -613,7 +613,7 @@ TupleBufferWait(TupleBuffer *buf, uint32_t cq_id, uint8_t reader_id)
 void
 TupleBufferResetNotify(TupleBuffer *buf, uint32_t cq_id, uint8_t reader_id)
 {
-	Latch *latches = dsm_array_get(buf->latches, cq_id);
+	Latch *latches = ShmemArrayGet(buf->latches, cq_id);
 	ResetLatch((&latches[reader_id]));
 }
 
@@ -624,7 +624,7 @@ void
 TupleBufferNotify(TupleBuffer *buf, uint32_t cq_id)
 {
 	int i;
-	Latch *latches = dsm_array_get(buf->latches, cq_id);
+	Latch *latches = ShmemArrayGet(buf->latches, cq_id);
 
 	for (i = 0; i < buf->max_readers; i++)
 	{
diff --git a/src/backend/storage/ipc/Makefile b/src/backend/storage/ipc/Makefile
index e89e63c56..4b100ee8a 100644
--- a/src/backend/storage/ipc/Makefile
+++ b/src/backend/storage/ipc/Makefile
@@ -17,6 +17,6 @@ endif
 
 OBJS = dsm_impl.o dsm.o ipc.o ipci.o pmsignal.o procarray.o procsignal.o \
 	shmem.o shmqueue.o shm_mq.o shm_toc.o sinval.o sinvaladt.o standby.o \
-	dsm_alloc.o dsm_array.o
+	shm_alloc.o shm_array.o
 
 include $(top_srcdir)/src/backend/common.mk
diff --git a/src/backend/storage/ipc/dsm_alloc.c b/src/backend/storage/ipc/shm_alloc.c
similarity index 60%
rename from src/backend/storage/ipc/dsm_alloc.c
rename to src/backend/storage/ipc/shm_alloc.c
index 69eee6255..ccc1a3cbe 100644
--- a/src/backend/storage/ipc/dsm_alloc.c
+++ b/src/backend/storage/ipc/shm_alloc.c
@@ -11,13 +11,11 @@
 #include "c.h"
 #include "miscadmin.h"
 #include "storage/lwlock.h"
-#include "storage/dsm_alloc.h"
+#include "storage/shm_alloc.h"
 #include "storage/shmem.h"
 #include "storage/spin.h"
 #include "utils/elog.h"
 
-#define DEBUG 0
-
 /* Memory Blocks */
 
 #define IS_ALIGNED(ptr) ((BlockInfo) ptr % __WORDSIZE == 0)
@@ -118,67 +116,14 @@ is_allocated(void *ptr)
  * making locking more fine grained.
  */
 
-typedef struct SPallocState
+typedef struct ShemDynAllocState
 {
 	void *head;
 	void *tail;
 	slock_t mutex;
-	/* DEBUG metadata */
-	int nblocks;
-	int nfree;
-	Size mem_size;
-	Size total_alloc;
-	Size total_free;
-} SPallocState;
-
-static SPallocState *GlobalSPallocState = NULL;
-
-static Size
-free_blocks_size()
-{
-	void *block;
-	Size size = 0;
-
-	block = GlobalSPallocState->head;
-	while (block)
-	{
-		size += BLOCK_SIZE(get_size(block));
-		block = get_next(block);
-	}
-
-	return size;
-}
+} ShemDynAllocState;
 
-static void
-print_block(void *block)
-{
-	if (!block)
-		return;
-	elog(LOG, "  addr: %p, end: %p, prev: %p, next: %p, size: %zu", block, get_end(block), get_prev(block), get_next(block), get_size(block));
-}
-
-static void
-print_allocator()
-{
-	void *block = GlobalSPallocState->head;
-	elog(LOG, "=== ShmemAllocator ===\n");
-
-	elog(LOG, "num free blocks %d", GlobalSPallocState->nfree);
-	elog(LOG, "total free: %zu", free_blocks_size());
-	elog(LOG, "num all blocks %d", GlobalSPallocState->nblocks);
-	elog(LOG, "total resident: %zu", GlobalSPallocState->mem_size);
-	elog(LOG, "head: %p", GlobalSPallocState->head);
-	elog(LOG, "tail: %p", GlobalSPallocState->tail);
-	elog(LOG, "blocks:");
-
-	while (block)
-	{
-		print_block(block);
-		block = get_next(block);
-	}
-
-	elog(LOG, "======================");
-}
+static ShemDynAllocState *GlobalShemDynAllocState = NULL;
 
 static bool
 coalesce_blocks(void *ptr1, void *ptr2)
@@ -208,11 +153,6 @@ coalesce_blocks(void *ptr1, void *ptr2)
 	if (next)
 		set_prev(next, ptr1);
 
-
-	if (DEBUG)
-		GlobalSPallocState->nblocks--;
-		GlobalSPallocState->nfree--;
-
 	return true;
 }
 
@@ -222,15 +162,6 @@ init_block(void *ptr, Size size, bool is_new)
 	Header *header = get_header(ptr);
 	header->size = size;
 	header->magic = MAGIC;
-
-	if (DEBUG)
-	{
-		SpinLockAcquire(&GlobalSPallocState->mutex);
-		GlobalSPallocState->nblocks++;
-		if (is_new)
-			GlobalSPallocState->mem_size += BLOCK_SIZE(size);
-		SpinLockRelease(&GlobalSPallocState->mutex);
-	}
 }
 
 static void
@@ -241,28 +172,28 @@ insert_block(void *ptr)
 
 	mark_free(ptr);
 
-	SpinLockAcquire(&GlobalSPallocState->mutex);
+	SpinLockAcquire(&GlobalShemDynAllocState->mutex);
 
-	if (!GlobalSPallocState->head)
+	if (!GlobalShemDynAllocState->head)
 	{
-		GlobalSPallocState->head = ptr;
-		GlobalSPallocState->tail = ptr;
+		GlobalShemDynAllocState->head = ptr;
+		GlobalShemDynAllocState->tail = ptr;
 	}
 	else
 	{
-		if ((intptr_t) ptr < (intptr_t) GlobalSPallocState->head)
+		if ((intptr_t) ptr < (intptr_t) GlobalShemDynAllocState->head)
 		{
-			next = GlobalSPallocState->head;
-			GlobalSPallocState->head = ptr;
+			next = GlobalShemDynAllocState->head;
+			GlobalShemDynAllocState->head = ptr;
 		}
-		else if ((intptr_t) ptr > (intptr_t) GlobalSPallocState->tail)
+		else if ((intptr_t) ptr > (intptr_t) GlobalShemDynAllocState->tail)
 		{
-			prev = GlobalSPallocState->tail;
-			GlobalSPallocState->tail = ptr;
+			prev = GlobalShemDynAllocState->tail;
+			GlobalShemDynAllocState->tail = ptr;
 		}
 		else
 		{
-			prev = GlobalSPallocState->head;
+			prev = GlobalShemDynAllocState->head;
 			while (prev)
 			{
 				next = get_next(prev);
@@ -284,8 +215,8 @@ insert_block(void *ptr)
 		set_next(prev, ptr);
 		if (coalesce_blocks(prev, ptr))
 		{
-			if (GlobalSPallocState->tail == ptr)
-				GlobalSPallocState->tail = prev;
+			if (GlobalShemDynAllocState->tail == ptr)
+				GlobalShemDynAllocState->tail = prev;
 			ptr = prev;
 		}
 	}
@@ -296,10 +227,7 @@ insert_block(void *ptr)
 		coalesce_blocks(ptr, next);
 	}
 
-	if (DEBUG)
-		GlobalSPallocState->nfree++;
-
-	SpinLockRelease(&GlobalSPallocState->mutex);
+	SpinLockRelease(&GlobalShemDynAllocState->mutex);
 }
 
 static void
@@ -323,9 +251,9 @@ get_block(Size size)
 	void *best = NULL;
 	int best_size;
 
-	SpinLockAcquire(&GlobalSPallocState->mutex);
+	SpinLockAcquire(&GlobalShemDynAllocState->mutex);
 
-	block = GlobalSPallocState->head;
+	block = GlobalShemDynAllocState->head;
 	while (block)
 	{
 		Size block_size = get_size(block);
@@ -352,75 +280,46 @@ get_block(Size size)
 		next = get_next(best);
 
 		if (!prev)
-			GlobalSPallocState->head = next;
+			GlobalShemDynAllocState->head = next;
 		else
 			set_next(prev, next);
 		if (!next)
-			GlobalSPallocState->tail = prev;
+			GlobalShemDynAllocState->tail = prev;
 		else
 			set_prev(next, prev);
-
-		if (DEBUG)
-			GlobalSPallocState->nfree--;
 	}
 
-	SpinLockRelease(&GlobalSPallocState->mutex);
+	SpinLockRelease(&GlobalShemDynAllocState->mutex);
 
 	return best;
 }
 
-static void
-test_allocator()
-{
-	void *a;
-	void *b;
-
-	print_allocator();
-	a = dsm_alloc(23);
-	b = dsm_alloc(500);
-	dsm_free(a);
-	dsm_free(b);
-	a = dsm_alloc(250);
-	b = dsm_alloc(120);
-	dsm_free(a);
-	dsm_free(b);
-	a = dsm_alloc(sizeof(void *) * 10);
-	b = dsm_alloc(sizeof(Header));
-	dsm_free(a);
-	dsm_free(b);
-}
-
 /*
- * InitSPallocState
+ * InitShmemDynAllocator
  */
 void
-InitDSMAlloc(void)
+InitShmemDynAllocator(void)
 {
 	bool found;
 
 	LWLockAcquire(PipelineMetadataLock, LW_EXCLUSIVE);
 
-	GlobalSPallocState = (SPallocState *) ShmemInitStruct("SPallocState", sizeof(SPallocState) , &found);
+	GlobalShemDynAllocState = (ShemDynAllocState *) ShmemInitStruct("SPallocState", sizeof(ShemDynAllocState) , &found);
 	if (!found)
 	{
-		GlobalSPallocState->head = NULL;
-		GlobalSPallocState->tail = NULL;
-		GlobalSPallocState->nblocks = 0;
-		GlobalSPallocState->nfree = 0;
-		SpinLockInit(&GlobalSPallocState->mutex);
+		GlobalShemDynAllocState->head = NULL;
+		GlobalShemDynAllocState->tail = NULL;
+		SpinLockInit(&GlobalShemDynAllocState->mutex);
 	}
 
 	LWLockRelease(PipelineMetadataLock);
-
-	if (DEBUG)
-		test_allocator();
 }
 
 /*
- * dsm_alloc
+ * ShmemDynAlloc
  */
 void *
-dsm_alloc(Size size)
+ShmemDynAlloc(Size size)
 {
 	void *block;
 	Size padded_size;
@@ -449,58 +348,33 @@ dsm_alloc(Size size)
 	if (get_size(block) - size >= MIN_BLOCK_SIZE)
 		split_block(block, size);
 
-	if (DEBUG)
-	{
-		SpinLockAcquire(&GlobalSPallocState->mutex);
-
-		GlobalSPallocState->total_alloc += size;
-		printf("> dsm_alloc %zu\n", size);
-		print_allocator();
-
-		SpinLockRelease(&GlobalSPallocState->mutex);
-	}
-
 	Assert(is_allocated(block));
 
 	return block;
 }
 
 void *
-dsm_alloc0(Size size)
+ShmemDynAlloc0(Size size)
 {
-	char *addr = dsm_alloc(size);
+	char *addr = ShmemDynAlloc(size);
 	MemSet(addr, 0, get_size(addr));
 	return addr;
 }
 
 /*
- * spfree
+ * ShmemDynFree
  */
 void
-dsm_free(void *addr)
+ShmemDynFree(void *addr)
 {
-	Size size;
+	if (!ShmemDynAddrIsValid(addr))
+		elog(ERROR, "ShmemDynFree: invalid/double freeing (%p)", addr);
 
-	if (!is_allocated(addr))
-		elog(ERROR, "spfree: invalid/double freeing (%p)", addr);
-
-	size = get_size(addr);
 	insert_block(addr);
-
-	if (DEBUG)
-	{
-		SpinLockAcquire(&GlobalSPallocState->mutex);
-
-		printf("> spfree %p\n", addr);
-		print_allocator();
-		GlobalSPallocState->total_free += size;
-
-		SpinLockRelease(&GlobalSPallocState->mutex);
-	}
 }
 
 bool
-dsm_is_valid_ptr(void *addr)
+ShmemDynAddrIsValid(void *addr)
 {
-	return is_allocated(addr);
+	return ShmemAddrIsValid(addr) && is_allocated(addr);
 }
diff --git a/src/backend/storage/ipc/dsm_array.c b/src/backend/storage/ipc/shm_array.c
similarity index 66%
rename from src/backend/storage/ipc/dsm_array.c
rename to src/backend/storage/ipc/shm_array.c
index c858ac5f9..f9c3b5f21 100644
--- a/src/backend/storage/ipc/dsm_array.c
+++ b/src/backend/storage/ipc/shm_array.c
@@ -9,41 +9,40 @@
  *-------------------------------------------------------------------------
  */
 #include "c.h"
-#include "storage/dsm_alloc.h"
-#include "storage/dsm_array.h"
+#include "storage/shm_alloc.h"
+#include "storage/shm_array.h"
 #include "storage/spin.h"
 #include "utils/elog.h"
 
-#define DEBUG 0
 #define ARRAY_SEGMENT_SIZE 32
 
 typedef struct DSMArraySegment {
 	struct DSMArraySegment *next;
 	uint8_t bytes[1];
-} DSMArraySegment;
+} ShmemArraySegment;
 
-struct DSMArray {
-	DSMArraySegment *tail;
+struct ShmemArray {
+	ShmemArraySegment *tail;
 	int length;
 	Size size;
 	slock_t mutex;
-	DSMArraySegment segment;
+	ShmemArraySegment segment;
 };
 
-DSMArray *dsm_array_new(Size size)
+ShmemArray *ShmemArrayInit(Size size)
 {
-	DSMArray *array = dsm_alloc0(sizeof(DSMArray) + (size * ARRAY_SEGMENT_SIZE));
+	ShmemArray *array = ShmemDynAlloc0(sizeof(ShmemArray) + (size * ARRAY_SEGMENT_SIZE));
 	array->length = ARRAY_SEGMENT_SIZE;
 	array->size = size;
 	SpinLockInit(&array->mutex);
 	return array;
 }
 
-static void *get_idx_addr(DSMArray *array, int idx)
+static void *get_idx_addr(ShmemArray *array, int idx)
 {
 	int offset;
 	int seg_num;
-	DSMArraySegment *segment;
+	ShmemArraySegment *segment;
 
 	if (idx >= array->length)
 		return NULL;
@@ -59,7 +58,7 @@ static void *get_idx_addr(DSMArray *array, int idx)
 	return (void *) &segment->bytes[offset];
 }
 
-void dsm_array_set(DSMArray *array, int idx, void *value)
+void ShmemArraySet(ShmemArray *array, int idx, void *value)
 {
 	void *addr;
 
@@ -69,8 +68,8 @@ void dsm_array_set(DSMArray *array, int idx, void *value)
 
 		while (idx >= array->length)
 		{
-			DSMArraySegment *tail;
-			DSMArraySegment *new = dsm_alloc0(sizeof(DSMArraySegment) * (array->size * ARRAY_SEGMENT_SIZE));
+			ShmemArraySegment *tail;
+			ShmemArraySegment *new = ShmemDynAlloc0(sizeof(ShmemArraySegment) * (array->size * ARRAY_SEGMENT_SIZE));
 
 			if (array->tail == NULL)
 				tail = &array->segment;
@@ -93,15 +92,15 @@ void dsm_array_set(DSMArray *array, int idx, void *value)
 		MemSet(addr, 0, array->size);
 }
 
-void *dsm_array_get(DSMArray *array, int idx)
+void *ShmemArrayGet(ShmemArray *array, int idx)
 {
 	void *addr = get_idx_addr(array, idx);
 	return addr ? addr : NULL;
 }
 
-void dsm_array_delete(DSMArray *array)
+void ShmemArrayDelete(ShmemArray *array)
 {
-	DSMArraySegment *segment;
+	ShmemArraySegment *segment;
 
 	if (!array)
 		return;
@@ -110,10 +109,10 @@ void dsm_array_delete(DSMArray *array)
 
 	while (segment)
 	{
-		DSMArraySegment *next = segment->next;
-		dsm_free(segment);
+		ShmemArraySegment *next = segment->next;
+		ShmemDynFree(segment);
 		segment = next;
 	}
 
-	dsm_free(array);
+	ShmemDynFree(array);
 }
diff --git a/src/backend/utils/init/pipelineinit.c b/src/backend/utils/init/pipelineinit.c
index 0f0141501..a321bbc18 100644
--- a/src/backend/utils/init/pipelineinit.c
+++ b/src/backend/utils/init/pipelineinit.c
@@ -15,7 +15,7 @@
 #include "miscadmin.h"
 #include "pipeline/cqproc.h"
 #include "pipeline/tuplebuf.h"
-#include "storage/dsm_alloc.h"
+#include "storage/shm_alloc.h"
 
 /*
  * InitPipeline
@@ -25,7 +25,7 @@
 void InitPipeline()
 {
 	srand(time(NULL));
-	InitDSMAlloc();
+	InitShmemDynAllocator();
 	TupleBuffersInit();
 	InitCQProcState();
 }
diff --git a/src/include/nodes/bitmapset.h b/src/include/nodes/bitmapset.h
index 0023e730f..4aa5606c1 100644
--- a/src/include/nodes/bitmapset.h
+++ b/src/include/nodes/bitmapset.h
@@ -97,7 +97,7 @@ extern int	bms_first_member(Bitmapset *a);
 extern uint32 bms_hash_value(const Bitmapset *a);
 
 /* shared memory bms */
-extern Bitmapset *dsm_bms_add_member(Bitmapset *bms, int x);
-extern void dsm_bms_free(Bitmapset *bms);
+extern Bitmapset *shm_bms_add_member(Bitmapset *bms, int x);
+extern void shm_bms_free(Bitmapset *bms);
 
 #endif   /* BITMAPSET_H */
diff --git a/src/include/pipeline/tuplebuf.h b/src/include/pipeline/tuplebuf.h
index d04fdef42..62a7b7321 100644
--- a/src/include/pipeline/tuplebuf.h
+++ b/src/include/pipeline/tuplebuf.h
@@ -15,7 +15,7 @@
 #include "nodes/bitmapset.h"
 #include "pipeline/cont_xact.h"
 #include "pipeline/stream.h"
-#include "storage/dsm_array.h"
+#include "storage/shm_array.h"
 #include "storage/s_lock.h"
 #include "storage/shmem.h"
 #include "storage/latch.h"
@@ -66,7 +66,7 @@ typedef struct TupleBuffer
 	uint64_t tail_id;
 	slock_t mutex;
 	Bitmapset *waiters;
-	DSMArray *latches;
+	ShmemArray *latches;
 	Latch writer_latch;
 } TupleBuffer;
 
diff --git a/src/include/storage/dsm_alloc.h b/src/include/storage/dsm_alloc.h
deleted file mode 100644
index b89367926..000000000
--- a/src/include/storage/dsm_alloc.h
+++ /dev/null
@@ -1,20 +0,0 @@
-/*-------------------------------------------------------------------------
- *
- * dsm_alloc.h
- *	  shared memory allocator
- *
- * src/include/storage/dsm_alloc.h
- *
- *-------------------------------------------------------------------------
- */
-#ifndef DSM_ALLOC_H
-#define DSM_ALLOC_H
-
-extern void InitDSMAlloc(void);
-
-extern void *dsm_alloc(Size size);
-extern void *dsm_alloc0(Size size);
-extern void dsm_free(void *addr);
-extern bool dsm_is_valid_ptr(void *);
-
-#endif   /* DSM_ALLOC_H */
diff --git a/src/include/storage/shm_alloc.h b/src/include/storage/shm_alloc.h
new file mode 100644
index 000000000..d282ffa51
--- /dev/null
+++ b/src/include/storage/shm_alloc.h
@@ -0,0 +1,20 @@
+/*-------------------------------------------------------------------------
+ *
+ * shm_alloc.h
+ *	  shared memory allocator
+ *
+ * src/include/storage/shm_alloc.h
+ *
+ *-------------------------------------------------------------------------
+ */
+#ifndef SHM_ALLOC_H
+#define SHM_ALLOC_H
+
+extern void InitShmemDynAllocator(void);
+
+extern void *ShmemDynAlloc(Size size);
+extern void *ShmemDynAlloc0(Size size);
+extern void ShmemDynFree(void *addr);
+extern bool ShmemDynAddrIsValid(void *);
+
+#endif   /* SHM_ALLOC_H */
diff --git a/src/include/storage/dsm_array.h b/src/include/storage/shm_array.h
similarity index 55%
rename from src/include/storage/dsm_array.h
rename to src/include/storage/shm_array.h
index 3986e1932..cc2f045f0 100644
--- a/src/include/storage/dsm_array.h
+++ b/src/include/storage/shm_array.h
@@ -10,11 +10,11 @@
 #ifndef DSM_ARRAY_H
 #define DSM_ARRAY_H
 
-typedef struct DSMArray DSMArray;
+typedef struct ShmemArray ShmemArray;
 
-extern DSMArray *dsm_array_new(Size size);
-extern void *dsm_array_get(DSMArray *array, int idx);
-extern void dsm_array_set(DSMArray *array, int idx, void *val);
-extern void dsm_array_delete(DSMArray *array);
+extern ShmemArray *ShmemArrayInit(Size size);
+extern void *ShmemArrayGet(ShmemArray *array, int idx);
+extern void ShmemArraySet(ShmemArray *array, int idx, void *val);
+extern void ShmemArrayDestroy(ShmemArray *array);
 
 #endif   /* DSM_ARRAY_H */
